/*----------------------------------------------------------------------------

  Light SSTP Client
  Copyright(C) 2001 Koumei Hashimoto, all rights reserved.

  sstp.cpp

----------------------------------------------------------------------------*/
#include "header.h"

/*----------------------------------------------------------------------------
	[J`
----------------------------------------------------------------------------*/
#define MY_LOCALHOST	"127.0.0.1"
#define MY_SAKURA_MUTEX	"sakura"
#define MY_SSP_MUTEX	"ssp"

/*----------------------------------------------------------------------------
	InitWinsock()
	Winsock 
----------------------------------------------------------------------------*/
BOOL InitWinsock(VOID)
{
	WORD wVersionRequested;
	INT  nErrorStatus;
	WSADATA wsaData;

	// Winsock o[W 1.1 v
	wVersionRequested = MAKEWORD(1, 1);

	__try
	{
		nErrorStatus = WSAStartup(wVersionRequested, &wsaData);
	}
	__except(EXCEPTION_EXECUTE_HANDLER)
	{
		nErrorStatus = -1;
	}

	if(nErrorStatus != 0)
	{
		return FALSE;
	}

	return TRUE;
}

/*----------------------------------------------------------------------------
	CheckSakuraMutex()
	SSTP T[o[݊mF
----------------------------------------------------------------------------*/
BOOL CheckSakuraMutex()
{
	//return TRUE;
	HANDLE hMutex;

	hMutex = OpenMutex(MUTEX_ALL_ACCESS, FALSE, MY_SAKURA_MUTEX);
	if(hMutex == NULL) 
	{
		hMutex = OpenMutex(MUTEX_ALL_ACCESS, FALSE, MY_SSP_MUTEX);
		if(hMutex == NULL) 
		{
			return FALSE;
		}

		CloseHandle(hMutex);
		return TRUE;
	}

	CloseHandle(hMutex);
	return TRUE;
}

/*----------------------------------------------------------------------------
	SSTPSendMessage()
	Ut؂ɒ点i\Pbggpj
----------------------------------------------------------------------------*/
#define SD_RECEIVE      0x00
#define SD_SEND         0x01
#define SD_BOTH         0x02

BOOL SSTPSendMessage(LPCSTR szServer, INT nPort, LPCSTR szData , string& strStatus)
{
	struct hostent *lpHostEntry;	// T[ȍw|C^
	struct sockaddr_in skServerIn;	// T[õAhX
	SOCKET hSocket;					// \Pbgnh
	DWORD dwServerAddr;				// T[oIPAhX
	CHAR szBuffer[200];				// Mobt@
	INT nBytesRead;					// MTCY

	BOOL bRet;
	INT nPos;

	string strSSTPServer;
	string strSendBuffer;

	// [J̏ꍇA݂`FbN
	if(!szServer || szServer[0] == '\0' || lstrcmp(szServer, "127.0.0.1") == 0 ||
		lstrcmp(szServer, "localhost") == 0)
	{
		if(!CheckSakuraMutex())
		{
			strStatus = "Server Not Found";
			return FALSE;
		}
	}

	// 
	bRet = FALSE;
	if(!szServer || lstrlen(szServer) == 0)
	{
		strSSTPServer = MY_LOCALHOST;
	}else
	{
		strSSTPServer = szServer;
	}

	// hSocket Ƀ\Pbg쐬
	hSocket = socket(PF_INET, SOCK_STREAM, 0);
	if(hSocket == INVALID_SOCKET)
	{
		strStatus = "Invalid Socket";
		goto AT_EXIT;
	}

	// IP AhXݒ
	dwServerAddr = inet_addr(strSSTPServer.c_str());
	if(dwServerAddr == -1) 
	{
		// cmr
		lpHostEntry = gethostbyname(strSSTPServer.c_str());
		if(lpHostEntry == NULL) 
		{
			strStatus = "No Host Entry";
			closesocket(hSocket);
			goto AT_EXIT;
		}else
		{
			// T[ȍ񂩂 IP AhX dwServerAddr ɃRs[
			dwServerAddr = *((DWORD *)((lpHostEntry->h_addr_list)[0]));
		}
	}

	// T[oAhX̍\̂ɃT[o IP AhXƃ|[gԍݒ
	skServerIn.sin_family       = AF_INET;				// C^[lbg
	skServerIn.sin_addr.s_addr  = dwServerAddr;			// T[o IP AhX
	skServerIn.sin_port         = htons((WORD)nPort);	// |[gԍ
	ZeroMemory(skServerIn.sin_zero, sizeof(skServerIn.sin_zero));

	// T[o֐ڑ
	if(connect(hSocket, (struct sockaddr*)&skServerIn, sizeof(skServerIn)) == SOCKET_ERROR)
	{
		strStatus = "Connection Failed";
		closesocket(hSocket);
		goto AT_EXIT;
	}

	strSendBuffer = szData;

	if(send(hSocket, strSendBuffer.c_str(), strSendBuffer.size(), 0) == SOCKET_ERROR)
	{
		strStatus = "Send Failed";
		shutdown(hSocket,SD_BOTH);
		closesocket(hSocket);
		goto AT_EXIT;
	}

	// Xe[^XM
	shutdown(hSocket,SD_SEND);

	while(1)
	{
		// obt@NA
		nBytesRead = recv(hSocket, szBuffer, sizeof(szBuffer), 0);

		// obt@OG[Ŕ
		if(nBytesRead == 0 || nBytesRead == SOCKET_ERROR)
		{
			break;
		}
		szBuffer[nBytesRead] = '\0';
		strStatus += szBuffer;
	}

	shutdown(hSocket,SD_RECEIVE);
	closesocket(hSocket);

	bRet = TRUE;

AT_EXIT:

	return bRet;
}
